package com.jiashi.dao;

import com.jiashi.service.CardInfo;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Repository
public interface CardInfoRepository extends JpaRepository<CardInfo, String>, JpaSpecificationExecutor<CardInfo> {

    @Transactional(rollbackFor = Exception.class)
    @Modifying
    @Query("update CardInfo set state=:state where id = :id")
    public void updateState(String id,Integer state);

    @Transactional(rollbackFor = Exception.class)
    @Modifying
    @Query("update CardInfo set state=:state where id in :ids")
    public void updateState(List<String> ids, Integer state);
}
